/*     "  2"
          
     .
   :
   -      
     - .
       Dev-C++ ver.4.9.9.2  -  
     ,     
         .
*/

#include <iostream>
#include <cstdlib>
#include <fstream>
#include <cstdio>

using namespace std;
#define MAXCLIENTS 100   //   

int br=0;               //     

struct client           //   
{
	int account;        //    - 
	char fname[20];     // 
	char lname[20];     // 
	int ballance;       // 
}gp;

struct Queue            //  ""
{
	client key;         //  
	Queue *next;        //  
};
//

void push( Queue *& first, Queue *&last, client num )//    
{
     Queue *p = last;   //     
     last = new Queue;  //    
     last->key = num;
     last->next = NULL;
     if( p != NULL ) p->next = last;
     if( first == NULL )
     {
         first = last;
     }
}

int pop( Queue *& first, Queue *&last, client& num )//     
{
     Queue *p = NULL;
     if( first )
     {
         num = first->key;
         p = first;
         first = first->next;
         if( first == NULL ) last = first;
         delete p;         
         return 1; 
     }
     else
         return 0;     
} 

int countQueueents( Queue *& first )  //      
{
    Queue *pCtr = NULL;
    int qLength = 0;
    pCtr = first;
    while( pCtr != NULL )
    {
         ++qLength;
         pCtr = pCtr->next;   
    }
    return qLength;
}

void showQueue( Queue *& first ) //    
{
    Queue* pCtr = NULL;
    pCtr = first;
    if( pCtr == NULL )
    {
         cout << " Opashkata e prazna.\n";
         return;
    }
    else
    {
        do
        {
           pCtr =pCtr->next;
        }while( pCtr != NULL );
    }
}

//************************
class ClientData   //    ClientData
{
private:

	int number;

public:
    Queue *first, *last;
    
	int add_client(client& p)  //-    
	{
		if (number >= MAXCLIENTS) 
		{
			return 0;
		}

		//list[number] = new client;
		//*list[number] = p;
        push( first, last, p );
        number++;
		br++;
		return 1;
	}
    //************************
	void edit_client(client& p,int n) //-             
	{
	
		Queue *iter = first;
		while( iter != NULL )
		{
               if( iter->key.account == n )
               {
                   iter->key = p;
               }
               iter = iter->next;
        }
	}
    //************************
	int del_client(client& p,int n) //-      
	{   
        Queue *tmp_first = NULL;
        Queue *tmp_last = NULL;
        client temp;
        while( first != NULL )
        {
               pop( first, last, temp );
               if( temp.account != n )
                 { push( tmp_first, tmp_last, temp );
                   cout << temp.fname << endl;
                 }

        }
        while( tmp_first != NULL )
        {
               pop( tmp_first, tmp_last, temp );
               push( first, last, temp );
        }
        number--;
        br--;
		return 0;
	}
    //***********************
	void output() //-      
	{
		Queue *iter = first;
		while( iter != NULL )
		{
               cout << "\n" << iter->key.account;
               cout << " " << iter->key.fname;
               cout << " " << iter->key.lname;
               cout << " " << iter->key.ballance;
               iter = iter->next;
        }
	}
    //************************
	ClientData()        // 
	{
		number=0;
		first = NULL;
		last = NULL;
	}
    ~ClientData()       // 
    {
        client temp;
        while( first  != NULL ) pop( first, last, temp );
    }
    //************************
    void save(ofstream& ostr) //-    
	{
	    int i;
	    ostr<<number<<endl;
	    Queue *iter = first;
	    cout << " Saved information for " << number << " clients. ";
	    for(i=0;i<number;i++) 
		{
		  ostr<<iter->key.account<<" "<<iter->key.fname<<" "<<iter->key.lname
			  <<" "<<iter->key.ballance<<endl;
		  if( number != 1 ) iter = iter->next;
		}
	    cout<<"\n\t\t-------------------- File is saved! ----------------"<<endl;
	    
	}
    //************************
    void load(ifstream& istr) //-    
	{
	    int i=0;
	    int broi = 0;
	    istr >> broi;
	    cout << "\nClients loaded: " << broi << " clients. ";
	    client temp_obj;
	    while(i<broi)
		{
    
	      istr>>temp_obj.account>>temp_obj.fname>>temp_obj.lname>>temp_obj.ballance;
	      push( first, last, temp_obj );
	      number++;
	      i++;
		}
	}
    //************************
    client input(void) //-    
	{
	    int i;
	    client p;
        Queue *iter = first;
	    cout<< "\n Enter data for new client:"<<endl;
	    cout<<"\n Account: ";
	    cin>>p.account;
	    for (i=0;i<number;i++)
		{
		    if( iter->key.account == p.account )
			{
              cout<<"\n Account already exist!"<<endl;
			  return input();
			}
		    iter = iter->next;
		}

	    cout<<"\n First name: ";
	    cin>>p.fname;
	    cout<<"\n Last name: ";
	    cin>>p.lname;
	    cout<<"\n Ballance: ";
	    cin>>p.ballance;
	    gp=p;

		return p;
	}
};       //     
//************************

int main()
{
	ClientData *ob = new ClientData;   //     
	                                   //    ClientData
	client p;
	int m,n;
	int num=1;

	ifstream ff;
    ff.open("clients.txt") ;
    ff.seekg (0, ios::end);
    int length = ff.tellg();
    ff.seekg (0, ios::beg);
	cout << "Length of the file: " << length << " bytes. ";
    if( length != 0 ) ob->load(ff);    //     

	do
	{
        cout<<"\n\t\t+-----------------------------------------------+";
        cout<<"\n\t\t|     $$$     FIRST INVESTMENT BANK      $$$    |";
		cout<<"\n\t\t+-----------------------------------------------+";
		cout<<"\n\t\t|		1.Add new client		|";
		cout<<"\n\t\t|		2.Edit client			|";
		cout<<"\n\t\t|		3.Delete client			|";
		cout<<"\n\t\t|		4.List of clients		|";
		cout<<"\n\t\t|		5.Save data in file		|";
		cout<<"\n\t\t|		6.Exit				|";
		cout<<"\n\t\t+-----------------------------------------------+"<<endl;
		cout<<"\n\n\t\t\t\t Your choice: ";
		cin>>m;
		cout<<endl;

		switch(m)
		{
			case 1:
			{	
				system("cls");
				ob->input();           //     
				ob->add_client(gp);    //    
				num++;
				break;
			}

			case 2:
			{	
				system("cls");
				cout<<"\n Input account for edit: ";
				cin>>n;

				cout<< "\n Enter data for new client:"<<endl;
				p.account=n;
				cout<<"\n First name: ";
				cin>>p.fname;
				cout<<"\n Last name: ";
				cin>>p.lname;
				cout<<"\n Ballance: ";
				cin>>p.ballance;
				ob->edit_client(p,n);  //     
				break;
			}
			case 3:
			{	
				system("cls");
				cout<<"\n Input account for delete: ";
				cin>>n;
				ob->del_client( gp,n); //     
				cout<<"\n Account deleted!"<<endl;
				break;
			}
			case 4:
			{
				system("cls");
				cout<<"\n List of clients:"<<endl;
				cout<<"-----------------------------------------------";
				ob->output();          //     
				cout<<"\n-----------------------------------------------";
				break;
			}
			case 5:
			{
				system("cls");
				ofstream ff("clients.txt");
				ob->save(ff);          //     
				break;
			}
		}

	}while(m!=6);
    system("PAUSE");
    delete ob;               //      
}
