//      .
//  T3_Currency calculator_Self.cpp.   Dev-C++ 4.9.9.2.
//     32  .
// Modification by:	Silvia Stoqnova, SIT, 1 course, 3 group, 61662190. 23.3.2017

/*
The program is for calculating the sum when going from one currency to another.
First it saves the exchange rates to files. 
The exchange rates are fixed by the Bulgarian National Bank and don't change.
When it's done it asks you what value you want to invert. 
Then into what currency you want to invert. And shows you the result.
*/

/*           .
     18    (    ,
        ).     !
      5          
   (       ).
    : ,  ,     Sleep().
           . 
   
       6 .
         Self    
          .

*/

#include <iostream>	//library for cin and cout
#include <fstream>	//library for files
#include <conio.h>	//library for getch
#include <Windows.h>//library for SetColor
#include <iomanip>	//library for setprecision

using namespace std;

void mainmenu();

ifstream inFile1;
ifstream inFile2;

double EUR1, ATS1, BEF1, DEM1, FRF1;
double EUR2, ATS2, BEF2, DEM2, FRF2;

void sleep(unsigned milliseconds)
{
	Sleep(milliseconds);
}

void SetColor(unsigned short color)		//funcion for changing the letters color with a number
{
	HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTextAttribute(hcon, color);
}

void currency1()
{
	inFile1.open("currency1.txt");	//opens the file

	if (inFile1.fail())		//check for errors
	{
		cout << "Error opening file1" << endl;
		_getch();
		exit(0);
	}

	inFile1 >> EUR1 >> ATS1 >> BEF1 >> DEM1 >> FRF1;
}

void currency2()
{
	inFile2.open("currency2.txt");	//opens the file

	if (inFile2.fail())		//check for errors
	{
		cout << "Error opening file2" << endl;
		_getch();
		exit(0);
	}

	inFile2 >> EUR2 >> ATS2 >> BEF2 >> DEM2 >> FRF2;
}

void calcE1(double &sumE1, double value1)
{
	system("cls");	//clears the creen 

	sumE1 = EUR1*value1;	//calculates the sum

	SetColor(8);	//changes the text color with a number to grey
	cout << "\nThe currency you invert from is BGN.";	//output text
	cout << "\nThe currency you invert to is EUR.";
	cout << "\nThe value you entered is " << value1;
	setprecision(0);
	cout << "\nThe exchange rate is 1 BGN for " << EUR1 << " EUR." << endl;
	cout << value1 << " BGN = " << sumE1 << " EUR." << endl;
	cout << value1 << " BGN = " << setprecision(3) << sumE1 << " EUR." << endl;
}

void calcA1(double &sumA1, double value1)
{
	system("cls");	 //clears the scren

	sumA1 = ATS1*value1;	//calculates the sum

	SetColor(8);	//changes the text color with a number to grey 
	cout << "\nThe currency you invert from is BGN.";	//output text
	cout << "\nThe currency you invert to is ATS.";
	cout << "\nThe value you entered is " << value1;
	setprecision(0);
	cout << "\nThe exchange rate is 1 BGN for " << ATS1 << " ATS." << endl;
	cout << value1 << " BGN = " << sumA1 << " ATS." << endl;
	cout << value1 << " BGN = " << setprecision(3) << sumA1 << " ATS." << endl;
}

void calcB1(double &sumB1, double value1)
{
	system("cls");	//clears the screen	

	sumB1 = BEF1*value1;	//claculates the sum

	SetColor(8);	//changes the tex color with a number to grey
	cout << "\nThe currency you invert from is BGN.";	//output text
	cout << "\nThe currency you invert to is BEF.";
	cout << "\nThe value you entered is " << value1;
	setprecision(0);
	cout << "\nThe exchange rate is 1 BGN for " << BEF1 << " BEF." << endl;
	cout << value1 << " BGN = " << sumB1 << " BEF." << endl;
	cout << value1 << " BGN = " << setprecision(3) << sumB1 << " BEF." << endl;
}

void calcD1(double &sumD1, double value1)
{
	system("cls");	//clears the scren

	sumD1 = DEM1*value1;	//calculates the sum

	SetColor(8);	//changes the text color with a number to grey
	cout << "\nThe currency you invert from is BGN.";	//output text
	cout << "\nThe currency you invert to is DEM.";
	cout << "\nThe value you entered is " << value1;
	setprecision(0);
	cout << "\nThe exchange rate is 1 BGN for " << DEM1 << " DEM." << endl;
	cout << value1 << " BGN = " << sumD1 << " DEM." << endl;
	cout << value1 << " BGN = " << setprecision(3) << sumD1 << " DEM." << endl;
}

void calcF1(double &sumF1, double value1)
{
	system("cls");	//clears the screen

	sumF1 = FRF1*value1;	//calculates the sum

	SetColor(8);	//change the text color with a number ot grey
	cout << "\nThe currency you invert from is BGN.";	//output text
	cout << "\nThe currency you invert to is FRF.";
	cout << "\nThe value you entered is " << value1;
	setprecision(0);
	cout << "\nThe exchange rate is 1 BGN for " << FRF1 << " FRF." << endl;
	cout << value1 << " BGN = " << sumF1 << " FRF." << endl;
	cout << value1 << " BGN = " << setprecision(3) << sumF1 << " FRF." << endl;
}

void calcE2(double &sumE2, double value2)
{
	system("cls");	//clears the screen 

	sumE2 = EUR2*value2;	//calculates the sum

	SetColor(8);	//change the text color with a number to grey
	cout << "\nThe currency you invert from is EUR.";	//output text
	cout << "\nThe currency you invert to is BGN.";
	cout << "\nThe value you entered is " << value2;
	setprecision(0);
	cout << "\nThe exchange rate is 1 EUR for " << EUR2 << " BGN." << endl;
	cout << value2 << " EUR = " << sumE2 << " BGN." << endl;
	cout << value2 << " EUR = " << setprecision(3) << sumE2 << " BGN." << endl;
}

void calcA2(double &sumA2, double value2)
{
	system("cls");	//clears the screen

	sumA2 = ATS2*value2;	//calculates the sum

	SetColor(8);	//change the text color with a number to grey
	cout << "\nThe currency you invert from is ATS.";	//output text
	cout << "\nThe currency you invert to is BGN.";
	cout << "\nThe value you entered is " << value2;
	setprecision(0);
	cout << "\nThe exchange rate is 1 ATS for " << ATS2 << " BGN." << endl;
	cout << value2 << " ATS = " << sumA2 << " BGN." << endl;
	cout << value2 << " ATS = " << setprecision(3) << sumA2 << " BGN." << endl;
}

void calcB2(double &sumB2, double value2)
{
	system("cls");	//clears the scren

	sumB2 = BEF2*value2;	//calculates the sum

	SetColor(8);	//changes the text color with a number to greay
	cout << "\nThe currency you invert from is BEF.";	//output text
	cout << "\nThe currency you invert to is BGN.";
	cout << "\nThe value you entered is " << value2;
	setprecision(0);
	cout << "\nThe exchange rate is 1 BEF for " << BEF2 << " BGN." << endl;
	cout << value2 << " BEF = " << sumB2 << " BGN." << endl;
	cout << value2 << " BEF = " << setprecision(3) << sumB2 << " BGN." << endl;
}

void calcD2(double &sumD2, double value2)
{
	system("cls");	//clears the screen

	sumD2 = DEM2*value2;	//calculates the sum

	SetColor(8);	//changes the text color with a number to grey
	cout << "\nThe currency you invert from is DEM.";	//output the text
	cout << "\nThe currency you invert to is BGN.";
	cout << "\nThe value you entered is " << value2;
	setprecision(0);
	cout << "\nThe exchange rate is 1 DEM for " << DEM2 << " BGN." << endl;
	cout << value2 << " DEM = " << sumD2 << " BGN." << endl;
	cout << value2 << " DEM = " << setprecision(3) << sumD2 << " BGN." << endl;
}

void calcF2(double &sumF2, double value2)
{
	system("cls");	//clears the screen

	sumF2 = FRF2*value2;	//calclulates the sum

	SetColor(8);	//changes the text color with a number to grey
	cout << "\nThe currency you invert from is FRF.";	//output text
	cout << "\nThe currency you invert to is BGN.";
	cout << "\nThe value you entered is " << value2;
	setprecision(0);
	cout << "\nThe exchange rate is 1 FRF for " << FRF2 << " BGN." << endl;
	cout << value2 << " FRF = " << sumF2 << " BGN." << endl;
	cout << value2 << " FRF = " << setprecision(3) << sumF2 << " BGN." << endl;
}

void calctofore()
{
	int chcalc1;	//int for the choice in main menu
	double value1;	//double for the value you want to invert
	double sumE1, sumA1, sumB1, sumD1, sumF1;	//takes the calculated sum from others function

	system("cls");	//clears the screen

	SetColor(11);	//change the text color with a number to blue
	cout << "\nCalculate from BGN to foreign currency";	//output text
	cout << "\n........................................";
	cout << "\n\tEnter value: ";
	cin >> setprecision(2) >> value1;	//entering the value you want to invert

	system("cls");	//clears the screen

	cout << "\n\n\tChoose the currency you want to invert to";	//output text
	cout << "\n\t1. Euro";
	cout << "\n\t2. Austrian shilling";
	cout << "\n\t3. Belgian franc";
	cout << "\n\t4. German mark";
	cout << "\n\t5. French franc";
	cout << "\n\t\tEnter your choice: ";
	cin >> chcalc1;	//enter number for the choice for action from the main menu

	if (chcalc1 < 1 || chcalc1 > 5)	//cheks if the number for action you enetered is not in range
	{
		SetColor(12);	//change the text color with a number to red
		cout << "\nYour choice is incorrect.";	//output text
		Sleep(2000);	//waits 2 seconds to read the screen
		mainmenu();	//go back to main menu
	}

	switch (chcalc1)
	{
	case 1:
		calcE1(sumE1, value1);	//calls function that calculates 
		Sleep(10000);			//waits 10 seconds to read the screen
		mainmenu();				//goes back to the main menu
		break;
	case 2:
		calcA1(sumA1, value1);	//calls function that calculates 
		Sleep(10000);			//waits 10 seconds to read the screen
		mainmenu();				//goes back to the main menu
		break;
	case 3:
		calcB1(sumB1, value1);	//calls function that calculates 
		Sleep(10000);			//waits 10 seconds to read the screen
		mainmenu();				//goes back to the main menu
		break;
	case 4:
		calcD1(sumD1, value1);	//calls function that calculates 
		Sleep(10000);			//waits 10 seconds to read the screen
		mainmenu();				//goes back to the main menu
		break;
	case 5:
		calcF1(sumF1, value1);	//calls function that calculates 
		Sleep(10000);			//waits 10 seconds to read the screen
		mainmenu();				//goes back to the main menu
		break;
	}
}

void calctobgn()
{
	int chcalc2;	//int for the choice from the main menu
	double value2;	//int for the value you want to invert into anther currency
	double sumE2, sumA2, sumB2, sumD2, sumF2;	//taking the sum calculated from the functions

	system("cls");	//clears the screen

	SetColor(11);	//change the text color wth a number to blue
	cout << "\nCalculate from foreign currency to BGN";	//output text
	cout << "\n........................................";
	cout << "\n\tEnter value: ";
	cin >> setprecision(2) >> value2;	//entering the value you want to invert 

	system("cls");	//clears the screen

	cout << "\n\n\tChoose the currency you want to invert from";	//output text
	cout << "\n\t1. Euro";
	cout << "\n\t2. Austrian shilling";
	cout << "\n\t3. Belgian franc";
	cout << "\n\t4. German mark";
	cout << "\n\t5. French franc";
	cout << "\n\t\tEnter your choice: ";
	cin >> chcalc2;	//entering number for choice 

	if (chcalc2 < 1 || chcalc2 > 5)	//if the entered number is out of range
	{
		SetColor(12);	//change the text color with a number to red
		cout << "\nYour choice is incorrect.";	//output text
		Sleep(2000);	//waits 2 seconds to read the screen
		mainmenu();	//go back to the main menu
	}

	switch (chcalc2)
	{
	case 1:
		calcE2(sumE2, value2);	//calls the function that calcualates
		Sleep(10000);			//sleep for 10 seconds to read the screen
		mainmenu();				//go back to main menu
		break;
	case 2:
		calcA2(sumA2, value2);	//calls the function that calcualates
		Sleep(10000);			//sleep for 10 seconds to read the screen
		mainmenu();				//go back to main menu
		break;
	case 3:
		calcB2(sumB2, value2);	//calls the function that calcualates
		Sleep(10000);			//sleep for 10 seconds to read the screen
		mainmenu();				//go back to main menu
		break;
	case 4:
		calcD2(sumD2, value2);	//calls the function that calcualates
		Sleep(10000);			//sleep for 10 seconds to read the screen
		mainmenu();				//go back to main menu
		break;
	case 5:
		calcF2(sumF2, value2);	//calls the function that calcualates
		Sleep(10000);			//sleep for 10 seconds to read the screen
		mainmenu();				//go back to main menu
		break;
	}
}

void seeall()
{
	system("cls");	//clears the screen

	int a;	//int for the number entered to go back to the main menu

	SetColor(5);	//change the text color with a number to purple
	cout << "\n\nThe exchange rate from BGN to foreign currency." << endl;
	SetColor(14);	//change the text color with a number to yellow
	cout << setw(10) << "EUR" << setw(10) << "ATS" << setw(10) << "BEF" << setw(10) << "DEM" << setw(10) << "FRF" << endl;
	cout << setw(10) << EUR1 << setw(10) << ATS1 << setw(10) << BEF1 << setw(10) << DEM1 << setw(10) << FRF1 << endl;

	SetColor(5);	//change the text color with a number to purple
	cout << "\n\nThe exchange rate from foreign currency to BGN." << endl;
	SetColor(14);	//change the text color with a number to yellow
	cout << setw(10) << "EUR" << setw(10) << "ATS" << setw(10) << "BEF" << setw(10) << "DEM" << setw(10) << "FRF" << endl;
	cout << setw(10) << EUR2 << setw(10) << ATS2 << setw(10) << BEF2 << setw(10) << DEM2 << setw(10) << FRF2 << endl;

	cout << "\n\nPress 1 to go back to main menu ";	//helping text
	cin >> a;	//entering number
	if (a = 1)	//cheks if the number is 1 to go back to the main menu
		mainmenu();
}

void mainmenu()
{
	int chmain;	//int for choice from the menu

	system("cls");	//clears the screen

	SetColor(7);	//change the text color with a number to white
	cout << "\n\n\t1.Calculate from BGN to foreign currency";	//output the possiblle actions
	cout << "\n\t2.Calculate from foreign currency to BGN";
	cout << "\n\t3.See all exchange rates";
	cout << "\n\t4.Exit";
	cout << "\n\t\tYour choice is: ";
	cin >> chmain;	//entering your choice with a number
	cout << endl;

	switch (chmain)
	{
	case 1:
		calctofore();	//calls function for the first case
		break;
	case 2:
		calctobgn();	//calls function for the second case
		break;
	case 3:
		seeall();		//calls function for the third case
		break;
	case 4:
        cout << "\n Modification by: Silvia Stoqnova, SIT, 1 course, 3 group, 61662190. 23.3.2017 \n\n";
	    system("pause"); 
		exit(1);	//exit the program
	}
}

int main()
{
	currency1();
	currency2();
	mainmenu();

	inFile1.close();
	inFile2.close();	
	
	return 0;
}
