//  T3_RPS Game_Self.cpp

//   :  ,  2 . : 20.10.2016

/*    T3_RPS Game_Self   
   -  -  (Rock - Paper - Scissors).
        (  -   ""),   
       - ,   .
  ,   ,   .
 ,    ( )  .   " ".
         .cpp     (start.h  rules.h).
         .
         (   ),   ( ) 
  :  ,     . 
           . 
*/

/*          8 .
        :
   -          ;           
   -      ()     (   );   
   -          ;
   -            ;      
   -     (   player);
   -      -   .
   
      :  1  5  + .
*/ 

#include <iostream>
#include <cmath>
#include <time.h>
#include <cstdlib>
#include <Windows.h> // za rabota s prozorci, cvetovi, zvukovi i drugi efekti

#include "start.h"
#include "rules.h"

#pragma comment(lib, "winmm.lib") // deklarator za izpolzvane na biblioteka za audio

using namespace std;

void start(); // funkciq za nachalo na igrata
void rules(); // funkciq za pravilata
void color(); // funkciq za cvetovete
void about(); // funkciq za avtora

void main () // glavna funkciq main, kudeto se namira menu-to
{ 
	int a;   // promenliva a
	do 
	{
		cout<<endl;
		cout<<endl;
		
		cout << " /********************************************\\" << endl;
	    cout << "     Welcome to Game Rock, Paper, Scissors!      " << endl;
	    cout << " \\____________________________________________/" << endl;
        cout<<endl;
		cout<<"       1.Start! "<<endl;
		cout<<"       2.Rules "<<endl;
		cout<<"       3.Color "<<endl;
	    cout<<"       4.About "<<endl;
		cout<<"       5.Exit "<<endl;
		PlaySound(TEXT("welcome.wav"), NULL,SND_ASYNC); // audio (glasov) efekt
		
		cout<<endl;
		cout<<endl;
		cout<<" Vuvedete svoq izbor: ";
	    cin>>a;  // zapisvane na izbora ni v promenlivata a
	while (a<1||a>5);
		switch (a)
		{
		case 1: start();break;
		case 2: rules();break;
		case 3: color();break;
		case 4: about();break;
		case 5: PlaySound(TEXT("byebye.wav"), NULL,SND_ASYNC);break;
		}
	}while (a!=5);
	cin.get();
    
	cout << endl << endl;
	system("pause");
}

void color() // funkciq color, koqto zamenq cveta na texta i fona
{
	int ch;  // za izbor

	do       // cikul do - while za izbirane na cvetovete
 	{
		system("cls");
		
			cout<<"            CHOOSE A THEME             "<<endl;
			cout<<"                                       "<<endl;
			cout<<"         1. Default Theme              "<<endl;
			cout<<"         2. Green Theme               "<<endl;
			cout<<"         3. Blue Lights                "<<endl;
			cout<<"         4. Pink Theme                 "<<endl;
			cout<<"         5. Electric Theme               "<<endl;
			cout<<"         6. Grey Theme                  "<<endl;
			cout<<"         7. BACK                       "<<endl;
			
			cout<<endl;
			cout<<"            Your choice: ";
		cin>> ch;
		while (ch<1||ch>7);
		switch(ch)
		{	
			case 1: 
					{
						SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),63); // bqlo
						break;
					}
			case 2:	
					{
						SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),46); //  zeleno 
						break;
					}
			case 3:
					{
						SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),30); //  sinio
						break;
					}
			case 4: 
					{
						SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),223); //  rozovo
						break;
					}
			case 5: 
					{
						SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),10); //  svetlo zeleno 
						break;
					}
			case 6:
					{
						SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),143); //  sivo 
						break;
					}
			case 7:
						break;	
		}
	} while(ch!=7);
	system("cls");
}

void about()  // funkciq about s informaciq za avtora
{
	system("cls");  
	cout<<"                                           "<<endl;
	cout<<"        Created by:                        "<<endl;
	cout<<"        Name:        Stoqn Stoichev        "<<endl;
	cout<<"        Fac. number: 61460164              "<<endl;
	cout<<"        Speciality:  KST                   "<<endl;
	cout<<"        Course:      2                     "<<endl;
	cout<<"        Group:       2a                    "<<endl;
	cout<<"                                           "<<endl;
	
	system("pause");
	system("cls");
}


